<script>
	import DTE from './components/DTE.svelte';
	import Stats from './components/Stats.svelte';
	import DataTable from './components/DataTable.svelte';
	import Chart from './components/Chart.svelte';

	let details = {};
	let url = "https://docs.google.com/spreadsheets/d/e/2PACX-1vTawfDOtApqhr_3KC4cQ9hWB8qVLQUkZnDmwALDtIzf8n8wITbUu7HGgzBe7X-a4lioqgn5CIgbUe42/pub?gid=0&single=true&output=csv";
	let promise = grabData(url);

	const CSVToArray = (data, delimiter = ",", omitFirstRow = false) =>
    data
        .slice(omitFirstRow ? data.indexOf("\n") + 1 : 0)
        .split("\r\n")
		.map(v => v.split(delimiter));

	async function grabData(url) {
		const response = await fetch(url)
		const raw = await response.text()
		const data = CSVToArray(raw, ',', true);
		details = data;
		return details;
	}

	function handleClick() {
		promise = grabData(document.getElementById('txtFetch').value);
	}

</script>

<main>
	<h1>htTP Calculator</h1>
	<div>
		<input 
			id="txtFetch"
			value="https://docs.google.com/spreadsheets/d/e/2PACX-1vTawfDOtApqhr_3KC4cQ9hWB8qVLQUkZnDmwALDtIzf8n8wITbUu7HGgzBe7X-a4lioqgn5CIgbUe42/pub?gid=0&single=true&output=csv"
			/>
		<button on:click={handleClick} class="go-button">
			Go
		</button>
		<i class="fas fa-question-circle"></i>
	</div>
	{#await promise}
	<p>...waiting</p>
	{:then details}
	<div class="flex-container">
		<div class="flex-item">
			<DTE statData={details}/>
		</div>
		<div class="flex-item">
			<Stats statData={details} />
		</div>
	</div>
		<div class="flex-container">
			<div class="flex-item">
				<Chart chartData={details} />
			</div>
			<div class="flex-item">
				<DataTable data={details} url={url} />
			</div>
		</div>
	{:catch error}
		{console.error(error)}
		<p>An error occurred!</p>
	{/await}
	<div class="ct-chart ct-perfect-fourth"></div>
</main>

<style>
	main {
		text-align: center;
		padding: 1em;
		max-width: 240px;
		margin: 0 auto;
	}

	h1 {
		color: #ff3e00;
		font-size: 4em;
		font-weight: 100;
	}

	@media (min-width: 640px) {
		main {
			max-width: none;
		}

		input {
			min-width: 40rem;
		}

		.go-button {
			min-width: 5rem;
		}
	}
</style>